<template>
  <div class="app">
    <v-sidebar @addPedal="addPedal" @addPedalboard="addPedalboard" />
    <div class="canvas" @click.self="unSelect">
      <v-pedal
        v-for="pedal in setup.pedals"
        :pedal="pedal"
        :key="`pedal_key_${pedal.id}`"
        @selectPedal="selectPedal"
        :pedal-selected="selectedPedal && selectedPedal.id === pedal.id"
      />
      <div style="padding: 10px" v-for="board in setup.pedalboards" :key="`pedalboard_key_${board.id}`">
        <v-pedal-board
            :pedalboard="board"
            @selectPedalboard="selectPedalboard"
            :pedalboard-selected="selectedPedalboard && selectedPedalboard.id === board.id"
        />
      </div>
    </div>
    <v-modal
      :visible="(selectedPedal && !!selectedPedal.pedal_id) || (selectedPedalboard && !!selectedPedalboard.pedalboard_id)"
      :title="(selectedPedal && selectedPedal.title) || (selectedPedalboard && selectedPedalboard.title)"
      @rotate="rotate"
      @delete="remove"
      @front="moveFront"
      @back="moveBack"
    />
  </div>
</template>

<script>
import { mapState, mapMutations } from 'vuex'
import VSidebar from '@/components/sidebar/sidebar'
import VModal from '@/components/modal/modal'
import VPedal from '@/components/pedal/pedal'
import VPedalBoard from '@/components/pedalboard/pedalboard'

import PedalModel from '@/models/pedal-model'
import PedalBoardModel from '@/models/pedalboard-model'
export default {
  components: {
    VSidebar,
    VModal,
    VPedal,
    VPedalBoard
  },
  data() {
    return {
      selectedPedal: null,
      selectedPedalboard: null,
      rotationOptions: ['right', 'bottom', 'left']
    }
  },
  created() {
    document.addEventListener('keydown', this.handleKeyDown)
  },
  computed: {
    ...mapState(['pedals', 'pedalboards', 'setup']),
  },
  methods: {
    ...mapMutations([
      'addPedalToSetup',
      'removePedalFromSetup',
      'updatePedalState',
      'addPedalboardToSetup',
      'removePedalboardFromSetup'
    ]),
    addPedal(pedal) {
      const payload = new PedalModel(pedal)
      this.addPedalToSetup(payload)
    },
    addPedalboard(payload) {
      const newPedaboard = new PedalBoardModel({ ...payload })
      this.addPedalboardToSetup(newPedaboard)
    },
    unSelect() {
      this.selectPedal(null)
    },
    selectPedal(pedal) {
      this.selectedPedal = pedal
    },
    selectPedalboard(pedalboard) {
      this.selectedPedalboard = pedalboard
    },
    rotate() {
      if (!this.selectedPedal.rotation) {
        this.selectedPedal.rotation = this.rotationOptions[0]
      } else {
        const i = this.rotationOptions.findIndex(option => option === this.selectedPedal.rotation)
        this.selectedPedal.rotation = this.rotationOptions[i + 1]
      }
      this.updatePedalState(this.selectedPedal)
    },
    moveFront() {
      this.selectedPedal.z++
      this.updatePedalState(this.selectedPedal)
    },
    moveBack() {
      if (this.pedal.z > 2) {
        this.selectedPedal.z--
        this.updatePedalState(this.selectedPedal)
      }
    },
    remove() {
      if (!!this.selectedPedal?.id) {
        this.removePedalFromSetup(this.selectedPedal.id)
        this.selectedPedal = null
      }

      if (!!this.selectedPedalboard?.id) {
        this.removePedalboardFromSetup(this.selectedPedalboard.id)
        this.selectedPedalboard = null
      }
    },
    handleKeyDown(e) {
      const allowedKeys = ['r', '[', ']', 'd']
      if (allowedKeys.includes(e.key) && this.selectedPedal !== null) {
        switch (e.key) {
          case 'r':
            this.rotate()
            break
          case '[':
            this.moveBack()
            break
          case ']':
            this.moveFront()
            break
          case 'd':
            this.removePedal()
            break
          default:
            console.log('YEET')
        }
      }
    }
  }
}
</script>

<style lang="scss">
.app {
  min-height: 100vh;
}

body {
  margin: 0;
  padding: 0;
  min-height: 100vh;
  box-sizing: border-box;
  font-family: 'Montserrat', sans-serif;
}

.canvas {
  display: flex;
  flex-flow: row wrap;
  position: relative;
  background-color: #2e3337;
  background-size: 25px;
  background-image: url('./assets/background.svg');
  width: calc(100% - 290px);
  transform: translateX(290px);
  min-height: 100vh;
  height: 100%;
  padding-bottom: 100px;
}
</style>
